// Neighborhood kernel functions for SOMs
// by Johannes Lampel / LampelSoft
// (c) Johannes Lampel / LampelSoft
// written Sept 13rd 2000

// z -> Distance of neurons
// d -> size of neighborhood kernel
#include <math.h>
#include "nVec.h"
#include "GlobalCqSOMDefs.h"

#define pi 3.14159265358979f

nVec_var DllExport fNKcos(const nVec_var &z,const nVec_var &d){	
	if(z < d)
		return (cos( z/d * pi/2.f));
	else
		return 0;
}

nVec_var DllExport fNKgauss1(const nVec_var &z,const nVec_var &d){
	return exp(-((z*z)/(d*d)));									// don't use pow(?,2),'cause it's to time expensive
}

nVec_var DllExport fNKgauss2(const nVec_var &z,const nVec_var &d){
	return (1.f-((z*z)/(d*d)))*fNKgauss1(z,d);
}

nVec_var DllExport fNKcyl(const nVec_var &z,const nVec_var &d){
	if(z < d)
		return 1.f;
	else
		return 0.f;
}

nVec_var DllExport fNKcone(const nVec_var &z,const nVec_var &d){
	if(z < d)
		return 1.f-(z/d);
	else
		return 0.f;
}