#include "nVec.h"

nVec :: ~nVec(){
#ifdef __SSE
	if(!iType && ppdDim) _aligned_free ( ppdDim );
#else
	if(!iType) delete [] ppdDim ;
#endif
	lCDim = 0;
	ppdDim = 0;
}

nVec nVec :: operator +(const nVec &NParam){
	try{
		if(lCDim != NParam.lCDim){
			throw IncompatibleVectors();
		}
			nVec TmpVec(lCDim);
			TmpVec = *this;
			TmpVec+=NParam;
			return TmpVec;
	}
	catch(IncompatibleVectors IV){
		cerr << " 'IncompatibleVectors' thrown by + " << lCDim << " + " << NParam.lCDim <<" : "<< &NParam <<endl;
		throw(IV);
	}
	return 0;			// error if this is executed
}

nVec nVec :: operator -(const nVec &NParam){
	try{
		if(lCDim != NParam.lCDim){
			throw IncompatibleVectors();
		}
		nVec TmpVec(lCDim);
		TmpVec = *this;
		TmpVec-=NParam;
		return TmpVec;
	}
	catch(IncompatibleVectors IV){
		cerr << " 'IncompatibleVectors' thrown by - " << lCDim << " + " << NParam.lCDim << " : "<< &NParam <<endl;
		throw(IV);
	}
	return 0;			// error if this is executed
}

nVec nVec :: operator *(const nVec_var dParam){
	nVec TmpVec(lCDim);
	TmpVec = *this;
	TmpVec*=dParam;
	return TmpVec;
}

nVec nVec :: operator /(const nVec_var dParam){
	nVec TmpVec(lCDim);
	TmpVec = *this;
	TmpVec/=dParam;
	return TmpVec;
}

nVec_var nVec :: CBLength(void){
	nVec_var dtemp=0;
	long lschl;
	for(lschl=0;lschl < lCDim;lschl++){
		dtemp += ppdDim[lschl];
	}
	return dtemp;
}

int nVec :: Save(FILE *fhd){
	return fwrite(ppdDim,sizeof(nVec_var),lCDim,fhd);
}

int nVec :: Load(FILE *fhd){
	if(ppdDim) return fread(ppdDim,sizeof(nVec_var),lCDim,fhd);
	return false;
}

void nVec::testout(void){
	long lschl;
	for(lschl=0;lschl < lCDim;lschl++){
		cout <<ppdDim[lschl]<<" ";
	}
	cout << endl;
}

// global functions

nVec operator *(nVec_var dParam,nVec &nParam){
	return (nParam.operator *(dParam));
}
