#include "../som/som.h"
#include "../size.h"

#define _DEC .5

qSOM2d gSOM;
SOMPattern SPRaw(_DIM);
SOMPattern SP(_DIM*_PATTERNPERINPUT);

void createPattern(void){
	SP.SetMaxPatternNum(SPRaw.GetNumP());

	nVec_var pPattern[_DIM*_PATTERNPERINPUT];

	long l,l1;
	for(l=0; l < SPRaw.GetNumP() - _PATTERNPERINPUT; l++){
		for(l1=0; l1 < _PATTERNPERINPUT; l1++){
			memcpy(&(pPattern[_DIM*l1]),SPRaw.pFPattern[l+l1].getData(),sizeof(nVec_var) * _DIM);
		}
		SP.AddPattern(pPattern);
	}
}

void main(void){
	clock_t s;
	clock_t gs;
	double speed;
	long lIter = 0;
	/*cout << "loading som" << endl;
	gSOM.Load("sound.som");*/
	cout << "creating SOM" << endl;
	gSOM.SetSize(_DIM*_PATTERNPERINPUT,_X,_Y);
	gSOM.InitWeights(Init_Random);
	gSOM.Save("untrained.som");
	cout << "loading som training data" << endl;
	SPRaw.Load("sound.spt");
	cout << SPRaw.GetNumP() << " raw pattern" <<endl;
	cout << "creating training pattern" << endl;
	createPattern();
	cout << SP.GetNumP() << " training pattern" << endl;
	cout << "saving real training data" << endl;
	SP.Save("realTData.spt");
	cout << "setting up distance params and learn rate :) "<<endl;
	gSOM.SetDistP(_X);
	gSOM.SetLRate(.2);
	gSOM.SetNKFunction(fNKcyl);

	SP.SetSOM(&gSOM);
	cout << "starting calculation ... "<< endl;
	gs = clock();
	for(;gSOM.GetDistP()>1.f;){
		s = clock();
		double dist = gSOM.GetDistP();
		SP.TeachEpochFast(.03,dist);
		gSOM.SetDistP(gSOM.GetDistP()-_DEC);
		speed = double(SP.GetNumP())*(_X*_Y*_DIM*_PATTERNPERINPUT)/((double)(clock()-s)/CLOCKS_PER_SEC)/1000.0;
		lIter ++;
		cout << lIter << " : " << speed << " kCPS "<<" : " << dist << " : "<<((double)(clock()-s)/CLOCKS_PER_SEC) << " - " <<((double)(clock()-gs)/CLOCKS_PER_SEC) / lIter * (_X/_DEC) / 3600.f<<endl;
	}

	cout << "saving som" << endl;
	gSOM.Save("ready.som");
}